<template>
<span class="OAuthButton OAuthButton-yandex"
    :class='{"OAuthButton--authorized": !!userinfo}'
    @click='clickLogin'>

    <span class="OAuthButton__photo">
        <img v-if='userinfo'
            :src='userinfo?.photo'
            width="100"
            height="100"
            alt=""/>
    </span>

    <span class="OAuthButton__signin" v-if='!userinfo'>Sign in with Yandex</span>
    <span class="OAuthButton__userinfo" v-else>
        <span v-text='userinfo.name'/>
        <small v-text='userinfo.email'/>
    </span>

    <span class="OAuthButton__logout" v-if='userinfo'
        @click.stop='clickLogout'
        title="Sign out">
        <span class="material-symbols-outlined icon" v-html='"&#XE9BA;"'/>
    </span>

</span>
</template>

<script lang="ts">
import {Vue, Options} from '@/vue';
@Options<YandexButton>({}) export default class YandexButton extends Vue {
    get userinfo() {
        return this.$store.state.yandex!.userinfo;
    }

    clickLogin() {
        console.log('IN');
        this.$store.dispatch('yandex/login');
    }

    clickLogout() {
        console.log('LO');
        this.$store.dispatch('yandex/logout');
    }
}
</script>

<style lang="less">
@import '@/style/vars';
.OAuthButton {
    &-yandex {
        border-color: rgb(53, 53, 53);
        background-color: rgb(53, 53, 53);
        color: whitesmoke;
    }

    &-yandex &__photo {
        background-image: url('@/img/yandex-logo.svg');
        background-size: 26px 26px;
    }

    &-yandex &__userinfo {
        & > span::first-letter {
            color: red;
        }
    }
}
</style>
